<?php
/*
 * $Horde: babel/translate.php,v 1.9 2005/01/03 14:34:48 jan Exp $
 *
 * Copyright 2002-2005 Jon Parise <jon@horde.org>
 * Copyright 2000, 2001 easyDNS Technologies Inc.
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/asl.php.
 */

define('BABEL_BASE', dirname(__FILE__));
require_once BABEL_BASE . '/lib/base.php';

$lang = @$_COOKIE['i18n_lang'];

if (isset($_POST['MODE']) && $_POST['MODE']=='edit') {
	parseInputVars('i','trim');
	$page_id = $i['page_id'];
	$string_id = $i['string_id'];
}

# get page info

$query = "SELECT CONCAT(path,'/',file) AS full, db_revision " .
	"FROM pages WHERE page_id=" . $page_id;
$q = $DB->query($query);
$r0 = $q->fetchRow();

$full = substr($r0['full'], strlen($CVS->cvsRoot()));

$where = $CVS->cvsRoot();
$title = 'Translation of ' . $full;
$subhead = '[ <b>' . makeLink('/view.php', 'i18n') . '</b> ] ';

if (isset($full)) {
	$where .= $full;
	$title = 'Translation for '.$full;
	$temp = explode('/', $full);
	$last = array_pop($temp);
	$path = '';
	foreach ($temp as $part) {
		if ($part) {
			$path .= '/' . $part;
			$subhead.= ' / <b>' . makeLink('/view.php'.$path, $part) . '</b>';
		}
	}
	$subhead.= ' / <b>' . makeLink('/strings.php'.$path.'/'.$last, $last) . '</b>';
}

require BABEL_TEMPLATES . '/common-header.inc';
require BABEL_TEMPLATES . '/page-header.inc';


# EDITING

if (isset($_POST['MODE']) && $_POST['MODE']=='edit') {

	# probably need some sanity checking, but ...

	if ($i['translation']) {

		# fix for macs
		$i['translation'] = str_replace("\r", "", $i['translation'] );

		unset($i['page_id']);
		$i['lang'] = $lang;
		$i['user'] = $USER->user;
		$i['ttime'] = '%NOW()';
		if (substr($i['translation'],0,1)=='%') {
			$i['translation'] = '%' . $i['translation'];
		}
		$query = 'REPLACE INTO translations ' . makeSQLInsert($i);
		$message = 'Translation recorded';

	} else {

		$query = sprintf("DELETE FROM translations WHERE string_id=%d AND lang='%s'",
			$i['string_id'],
			$lang
		);
		$message = 'Translation deleted';

	}

	$q = $DB->query($query);

	echo <<< EOF
<table class="outline-alert" width="100%" border="0" cellspacing="1" cellpadding="0">
<tr><td>
<table width="100%" border="0" cellspacing="1" cellpadding="2">
<tr class="alert">
 <td>{$message}.</td>
</tr>
</table>
</td></tr>
</table>
<br>

EOF;

}




$query = sprintf(
	"SELECT * FROM strings WHERE string_id=%d",
	$string_id
);
$q = $DB->query($query);
$s = $q->fetchrow();

$query = sprintf(
	"SELECT * FROM translations WHERE string_id=%d AND lang='%s'",
	$string_id,
	$lang
);
$q = $DB->query($query);
if ($q->numrows()!=0) {
	$s2 = $q->fetchrow();
	$s = array_merge($s,$s2);
} else {
	$s['lang']			= NULL;
	$s['translation']	= NULL;
	$s['user']			= NULL;
	$s['db_revision']	= NULL;
	$s['ttime']			= NULL;
}


echo <<< EOF
<table class="outline-lite" width="100%" border="0" cellspacing="1" cellpadding="0">
<tr><td> 
<form method="POST" action="{$PHP_SELF}">
<input type="hidden" name="MODE" value="edit">
<input type="hidden" name="i::page_id" value="{$page_id}">
<input type="hidden" name="i::string_id" value="{$string_id}">
<input type="hidden" name="i::db_revision" value="{$r0['db_revision']}">
<table width="100%" border="0" cellspacing="1" cellpadding="2">
EOF;

echo '<tr valign="baseline" class="header2">';
echo '<th colspan="2" align="left">File<br></th>';
echo '</tr>';

echo '<tr valign="baseline">';
echo '<td class="item0" width="20%" align="right">File:<br></td>';
echo '<td class="item1" width="80%">' . $full . '<br></td>';
echo '</tr>';

echo '<tr valign="baseline">';
echo '<td class="item0" width="20%" align="right">Page ID:<br></td>';
echo '<td class="item1" width="80%">' . $page_id . '<br></td>';
echo '</tr>';

echo '<tr valign="baseline">';
echo '<td class="item0" width="20%" align="right">String ID:<br></td>';
echo '<td class="item1" width="80%">' . $s['string_id'] . '<br></td>';
echo '</tr>';

echo '<tr valign="baseline" class="header2">';
echo '<th colspan="2" align="left">Base String<br></th>';
echo '</tr>';

echo '<tr valign="baseline">';
echo '<td class="item0" width="20%" align="right">Revision:<br></td>';
echo '<td class="item1" width="80%">' . $r0['db_revision'] . '<br></td>';
echo '</tr>';

echo '<tr valign="baseline">';
echo '<td class="item0" width="20%" align="right">String:<br></td>';
echo '<td class="item1" width="80%"><code class="trans">' . showNice(htmlentities($s['string'])) . '</code></td>';
echo '</tr>';

echo '<tr valign="baseline">';
echo '<td class="item0" width="20%" align="right">Comments:<br></td>';
echo '<td class="item1" width="80%">';
if ($s['comment']) {
	$comments = explode('|', $s['comment']);
	$temp = str_replace('%%', '', $s['string']);
	preg_match_all('/%(\d+\$)?(0| )?(-)?(\d+)?(.\d+)?[bcdeufosxX]/', $temp, $m);
	echo '<table border="0">';
	foreach ($comments as $comment) {

		if (sizeof($m[0])) {
			$f = '<code class="trans">' . array_shift($m[0]) . '</code>';
		} else {
			$f = '<br>';
		}

		echo '<tr>';
		echo '<td>' . $f . '</td>';
		echo '<td>=<br></td>';
		echo '<td>' . $comment . '<br></td>';
		echo '</tr>';
	}
	echo '</table>';
} else {
	echo htmlentities($s['comment']) . '<br>';
}
echo '</td>';
echo '</tr>';

echo '<tr valign="baseline">';
echo '<td class="item0" width="20%" align="right">Checksum:<br></td>';
echo '<td class="item1" width="80%">' . $s['checksum'] . '<br></td>';
echo '</tr>';


echo '<tr valign="baseline" class="header2">';
echo '<th colspan="2" align="left">' . $lang . ' Translation<br></th>';
echo '</tr>';

echo '<tr valign="baseline">';
echo '<td class="item0" width="20%" align="right">Revision:<br></td>';
echo '<td class="item1" width="80%">' . ($s['db_revision'] ? $s['db_revision'] : '<i>new</i>') . '<br></td>';
echo '</tr>';

echo '<tr valign="top">';
echo '<td class="item0" width="20%" align="right">Translation:<br></td>';
echo '<td class="item1" width="80%">';
echo '<textarea cols="72" rows="10" name="i::translation" class="trans">' . HTMLEntities($s['translation']) . '</textarea><br></td>';
echo '</tr>';

echo '<tr valign="top">';
echo '<td class="item0" width="20%" align="right">Author:<br></td>';
echo '<td class="item1" width="80%">' . $s['user'] . '<br></td>';
echo '</tr>';

echo '<tr valign="top">';
echo '<td class="item0" width="20%" align="right">Date:<br></td>';
echo '<td class="item1" width="80%">' . $s['ttime'] . '<br></td>';
echo '</tr>';

echo '<tr valign="baseline" class="header2">';
echo '<th align="left">';
echo '<input type="button" value="Cancel" onClick="history.back();"> ';
echo '<br></th>';
echo '<th align="left">';
echo '<input type="reset" value="Reset"> ';
echo '<input type="submit" value="Commit"> ';
echo '<br></th>';
echo '</tr>';

echo <<< EOF
</table>  
</form>      
</td></tr>
</table>
EOF;

require $registry->get('templates', 'horde') . '/common-footer.inc';
